--
-- mAddon
-- Copyright (C) 2010 Mcstabin
-- Created by Mcstabin of Hellscream
--
-- mAddon is basically an extremely light version of AceAddon-3.0
--

if mAddon then return end

mAddon = {}
mAddon.frame = mAddon.frame or CreateFrame("Frame", "mAddonFrame") -- mAddon frame
mAddon.addons = mAddon.addons or {} -- mAddon addons
mAddon.initqueue = mAddon.initqueue or {} -- addons that are new and not initialized
mAddon.enablequeue = mAddon.enablequeue or {} -- addons that are initialized and waiting to be enabled

-- Lua APIs
local tinsert, tconcat, tremove = table.insert, table.concat, table.remove
local fmt, tostring = string.format, tostring
local select, pairs, next, type, unpack = select, pairs, next, type, unpack
local loadstring, assert, error = loadstring, assert, error
local setmetatable, getmetatable, rawset, rawget = setmetatable, getmetatable, rawset, rawget

local Embed, NewModule, GetName

function mAddon:NewAddon(name)
	local object = {}
	object.name = name
	
	object = object or {}
	object.name = name

	local addonmeta = {}
	local oldmeta = getmetatable(object)
	if oldmeta then
		for k, v in pairs(oldmeta) do addonmeta[k] = v end
	end
	addonmeta.__tostring = addontostring
	
	setmetatable(object, addonmeta)
	self.addons[name] = object
	object.modules = {}
	object.defaultModuleLibraries = {}
	Embed(object)
	
	-- add to queue of addons to be initialized upon ADDON_LOADED
	tinsert(self.initqueue, object)
	return object
end

function NewModule(self, name)
	local module = mAddon:NewAddon(fmt("%s_%s", self.name or tostring(self), name))
	
	module.IsModule = IsModuleTrue
	module.moduleName = name
	self.modules[name] = module
	
	return module
end

function Print(self,msg)
	return print('|cffFFFF00'..self.name..'|r: '..msg)
end

function GetName(self)
	return self.moduleName or self.name
end

local mixins = {
	NewModule = NewModule,
	Print = Print,
	GetName = GetName,
}
function Embed(target)
	for k, v in pairs(mixins) do
		target[k] = v
	end
end

function mAddon:InitAddon(addon)
	addon:Init()
end

local function onEvent(this, event, arg1)
	if event == "ADDON_LOADED" or event == "PLAYER_LOGIN" then
		while(#mAddon.initqueue > 0) do
			local addon = tremove(mAddon.initqueue, 1)
			if event == "ADDON_LOADED" then addon.baseName = arg1 end
			mAddon:InitAddon(addon)
		end
	end
end

mAddon.frame:RegisterEvent("ADDON_LOADED")
mAddon.frame:RegisterEvent("PLAYER_LOGIN")
mAddon.frame:SetScript("OnEvent", onEvent)