--
-- mUI
-- Copyright (C) 2010 Mcstabin
-- Created by Mcstabin of Hellscream
--

local Options = mUI:NewModule('Options')

mUI.defaultOpts = {
	profile = {
		mouseOver = {
			microMenu = false,
			stanceBar = false,
			petBar = false
		},
		moveSocialButton = false,
		enhancedTooltip = true,
		tooltipClassBorder = true,
		--unitFrames = true,
	}
}

local function SlashCommand(cmd)
	
	cmd = {strsplit(" ", cmd)}
	
	if cmd[1] then
		----------
		-- Toggle
		----------
		if cmd[1] == "toggle" then
			if cmd[2] == "micromenu" then
				if mUI.opt.mouseOver.microMenu then
					mUI.opt.mouseOver.microMenu = false
					mUI:Print('Mouse over micro menu disabled')
				else
					mUI.opt.mouseOver.microMenu = true
					mUI:Print('Mouse over micro menu enabled')
				end
				
				return true
			elseif cmd[2] == "petbar" then
				if mUI.opt.mouseOver.petBar then
					mUI.opt.mouseOver.petBar = false
					mUI:Print('Mouse over pet bar disabled')
				else
					mUI.opt.mouseOver.petBar = true
					mUI:Print('Mouse over pet bar enabled')
				end
				
				return true
			elseif cmd[2] == "stancebar" then
				if mUI.opt.mouseOver.stanceBar then
					mUI.opt.mouseOver.stanceBar = false
					mUI:Print('Mouse over stance bar disabled')
				else
					mUI.opt.mouseOver.stanceBar = true
					mUI:Print('Mouse over stance bar enabled')
				end
				
				return true
			elseif cmd[2] == "tooltips" then
				if mUI.opt.enhancedTooltip then
					mUI.opt.enhancedTooltip = false
					mUI:Print('Enhanced tooltips disabled')
				else
					mUI.opt.enhancedTooltip = true
					mUI:Print('Enhanced tooltips enabled')
				end
				
				return true
			--[[elseif cmd[2] == "unitframes" then
				if mUI.opt.customUnitFrames then
					mUI.opt.customUnitFrames = false
					mUI:Print('Custom unit frames disabled')
				else
					mUI.opt.customUnitFrames = true
					mUI:Print('Custom unit frames enabled')
				end
				
				return true]]
			elseif cmd[2] == "movesocialbutton" then
				if mUI.opt.moveSocialButton then
					mUI.opt.moveSocialButton = false
					mUI:Print('Move social button to micro menu disabled')
				else
					mUI.opt.moveSocialButton = true
					mUI:Print('Move social button to micro menu enabled')
				end
				
				return true
			else
				
			end
		end
	end
	
	mUI:Print("Options for mUI:")
	mUI:Print("  toggle")
	mUI:Print("    micromenu, petbar, stancebar, tooltips, unitframes, movesocialbutton")
	--mUI:Print("--    micromenu")
	--mUI:Print("--    petbar")
	--mUI:Print("--    stancebar")
	--mUI:Print("--    tooltips")
	--mUI:Print("--    unitframes")
	mUI:Print("Please note: when you set your options, you need to reload your UI.")
	
 	return false
end

function Options:Init()
	SLASH_MUI1 = "/mui";
	SlashCmdList["MUI"] = SlashCommand;
end