--
-- mUI
-- Copyright (C) 2010 Mcstabin
-- Created by Mcstabin of Hellscream
--

local function GetNumShapeSlots()
    local _,class = UnitClass('Player')
    if (class == 'DEATHKNIGHT' or class == 'WARRIOR') then
        return 3
    elseif (class == 'ROGUE') then
        return 1
	elseif (class == 'PALADIN') then
		return 5
    else
        return 10
    end
end

local function EnableMouseOver(self, bar, min, max)
    for i = min, max do
        local button = _G[self..i]
        
        local f = CreateFrame('Frame', bar, bar)
        f:RegisterEvent('PLAYER_LOGIN')
        f:SetFrameStrata('LOW')
        f:SetFrameLevel(1)
        f:EnableMouse()
        f:SetPoint('TOPLEFT', self..min)
        f:SetPoint('BOTTOMRIGHT', self..max)
        f:SetScript('OnEvent', function(self)
            bar:SetAlpha(0)
            self:UnregisterAllEvents()
        end)
        
        f:SetScript('OnEnter', function()
            bar:SetAlpha(1)
        end)
                    
        f:SetScript('OnLeave', function() 
            if (not MouseIsOver(button)) then
                bar:SetAlpha(0)
            end
        end)
    
        button:HookScript('OnEnter', function()
            bar:SetAlpha(1)
        end)
            
        button:HookScript('OnLeave', function() 
            if (not MouseIsOver(f)) then
                bar:SetAlpha(0)
            end
        end)
    end
end

local microButtons = {
	'CharacterMicroButton',
	'SpellbookMicroButton',
	'TalentMicroButton',
	'AchievementMicroButton',
	'QuestLogMicroButton',
	'GuildMicroButton',
	'PVPMicroButton',
	'LFDMicroButton',
	'MainMenuMicroButton',
	'HelpMicroButton',
}

local function showMicroButtons()
	for _,btn in pairs(microButtons) do
		local button = _G[btn]
		button:SetAlpha(1)
	end
end
local function hideMicroButtons()
	for _,btn in pairs(microButtons) do
		local button = _G[btn]
		button:SetAlpha(0)
	end
end

local function XPBarWidth(width)
	local divWidth = width/20;
	local xpos = divWidth - 4.5;
	for i=1,19 do
		local texture = _G["MainMenuXPBarDiv"..i];
		if not texture then
			texture = MainMenuExpBar:CreateTexture("MainMenuXPBarDiv"..i, "OVERLAY");
			texture:SetTexture("Interface\\MainMenuBar\\UI-XP-Bar");
			texture:SetSize(9,9);
			texture:SetTexCoord(0.01562500, 0.15625000, 0.01562500, 0.17187500);
		end
		local xalign = floor(xpos);
		texture:SetPoint("LEFT", xalign, 1);
		xpos = xpos + divWidth;
	end
	_G['MainMenuXPBarTextureMid']:SetWidth(width-28)
	_G['MainMenuExpBar']:SetWidth(width)
end

function mUI:shortBar()
	-- Move the social button back into the micro menu.
	if self.opt.moveSocialButton then
		if self.opt.moveSocialButton then
			table.insert(microButtons, 'FriendsMicroButton')
		end
		
		FriendsMicroButton:SetHeight(35)
		FriendsMicroButton:SetWidth(34)
		FriendsMicroButton:ClearAllPoints()
		FriendsMicroButton:SetPoint("LEFT", GuildMicroButton, "RIGHT", -5, -10.5)
		PVPMicroButton:ClearAllPoints()
		PVPMicroButton:SetPoint("LEFT", FriendsMicroButton, "RIGHT", -6, 10.5)
	end
	
	-- Stop the game handling frame positions
	for _,frame in pairs({
		'MultiBarRight',
		'MultiBarBottomRight',
		'ShapeshiftBarFrame',
		'PossessBarFrame',
		'MULTICASTACTIONBAR_YPOS',
		'MultiCastActionBarFrame',
		'PETACTIONBAR_YPOS',
		'CharacterMicroButton',
	}) do
		UIPARENT_MANAGED_FRAME_POSITIONS[frame] = nil
	end

	-- Hide crap we dont need (for now)
	for _,btn in pairs({
		_G['ActionBarUpButton'],
		_G['ActionBarDownButton'],
		_G['MainMenuBarBackpackButton'],
		_G['KeyRingButton'],
		_G['CharacterBag0Slot'],
		_G['CharacterBag1Slot'],
		_G['CharacterBag2Slot'],
		_G['CharacterBag3Slot'],
	}) do
		btn:SetAlpha(0)
		btn:EnableMouse(false)
	end

	-- Update MainMenuBar width
	MainMenuBar:SetWidth(512)

	-- Fix some widths
	for _, bar in pairs({
		_G['MainMenuExpBar'],
		_G['MainMenuBarMaxLevelBar'],
		_G['ReputationWatchStatusBar'],
		_G['ReputationWatchBar'],
	}) do
		bar:SetWidth(512)
	end

	-- Move MultiBarBottomRight
	MultiBarBottomRight:ClearAllPoints()
	MultiBarBottomRight:SetPoint('BOTTOM', MultiBarBottomLeft, 'TOP', 0, 4)
	MultiBarBottomRight.SetPoint = function() end

	-- Move PetActionBarFrame
	PetActionBarFrame:ClearAllPoints()
	PetActionBarFrame:SetPoint('BOTTOMRIGHT', MultiBarBottomRight, 'TOPRIGHT', 100, 2)
	PetActionBarFrame.SetPoint = function() end
	PetActionBarFrame:SetScale(0.75)

	-- Move ShapeshiftBarFrame
	ShapeshiftBarFrame:ClearAllPoints()
	ShapeshiftBarFrame:SetPoint('BOTTOMLEFT', MultiBarBottomRight, 'TOPLEFT', -10, 2)
	ShapeshiftBarFrame.SetPoint = function() end
	ShapeshiftBarFrame:SetScale(0.75)

	-- Move the totem bar
	MultiCastActionBarFrame:ClearAllPoints()
	MultiCastActionBarFrame:SetPoint("BOTTOMLEFT", MultiBarBottomRight, "TOPLEFT", 0, 0)
	MultiCastActionBarFrame.SetPoint = function() end
	
	if self.opt.mouseOver.stanceBar then
		ShapeshiftBarFrame:SetFrameStrata('HIGH')
		EnableMouseOver('ShapeshiftButton', ShapeshiftBarFrame, 1, GetNumShapeSlots())
	end

	if self.opt.mouseOver.petBar then
		PetActionBarFrame:SetFrameStrata('HIGH')
		EnableMouseOver('PetActionButton', PetActionBarFrame, 1, 10)
	end
	
	if self.opt.mouseOver.microMenu then
		for _,btn in pairs(microButtons) do
			local button = _G[btn]
			
			if not btn == "CharacterMicroButton" then
				button:UnregisterAllEvents()
			end
			button:SetAlpha(0)
			button:HookScript('OnEnter', function()
				showMicroButtons()
			end)
				
			button:HookScript('OnLeave', function() 
				hideMicroButtons()
			end)
		end
	end

	-- Hide uneeded textures
	local f = CreateFrame('Frame')
	f:Hide()
	for i = 2, 3 do
		for _, texture in pairs({
			_G['MainMenuBarTexture'..i],
			_G['MainMenuMaxLevelBar'..i],
			_G['MainMenuBarPageNumber'],
			_G['SlidingActionBarTexture0'],
			_G['SlidingActionBarTexture1'],
			
			--_G['MainMenuXPBarTexture'..i],
			--_G['MainMenuXPBarTextureLeftCap'],
			--_G['MainMenuXPBarTextureMid'],
			--_G['MainMenuXPBarTextureRightCap'],
			_G['ReputationWatchBarTexture'..i],
			_G['ReputationXPBarTexture'..i],
			_G['ShapeshiftBarLeft'],
			_G['ShapeshiftBarMiddle'],
			_G['ShapeshiftBarRight'],
			--_G['PossessBackground1'],
			--_G['PossessBackground2'],
		}) do
			texture:SetParent(f)
		end
	end
	
	-- Fix the main bar textures
	MainMenuBarTexture0:SetPoint('BOTTOM', MainMenuBarArtFrame, -128, 0)
	MainMenuBarTexture1:SetPoint('BOTTOM', MainMenuBarArtFrame, 128, 0)
	MainMenuMaxLevelBar0:SetPoint('BOTTOM', MainMenuBarMaxLevelBar, 'TOP', -128, 0)
	MainMenuBarLeftEndCap:SetPoint('BOTTOM', MainMenuBarArtFrame, -289, 0)
	MainMenuBarLeftEndCap.SetPoint = function() end
	MainMenuBarRightEndCap:SetPoint('BOTTOM', MainMenuBarArtFrame, 289, 0)
	MainMenuBarRightEndCap.SetPoint = function() end

end
----------
local eventFrame = CreateFrame("Frame", "mUIShortBarEventFrame", UIParent)
eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
eventFrame:RegisterEvent("UNIT_EXITED_VEHICLE");
eventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
eventFrame:RegisterEvent("PLAYER_TALENT_UPDATE");
eventFrame:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD"
	or event == "UNIT_EXITED_VEHICLE"
	or event == "ACTIVE_TALENT_GROUP_CHANGED"
	or event == "PLAYER_TALENT_UPDATE"
	then
		XPBarWidth(512)
	end
end)